
// Segment 1 - Machine-independent initialisation and finalisation


GET "ML1HDR"

STATIC $( exit_p = 0; exit_l = 0; result = 0 $)

LET milogic(workspace, size) = VALOF
/* Machine-independent initialisation code. */
$( LET ght = VEC lhv + 4
   AND svec = VEC svarnum
   AND tv = VEC 7/bytesperword

   ghshtb, typvec := ght, tv
   hashpt := ghshtb

// writef("...in milogic(%N, #X%X8)*n", workspace, size)
   /* Set up system variables, initialising to zero */

   svarpt := svec + svarnum             // S-variables are stored backwards
   !svarpt := svarnum
   FOR i = 0 TO svarnum - 1 DO svec!i := 0
   at_s1 := svarpt - 1                  // Address of S1 - for efficiency
   at_s2 := svarpt - 2                  // Address of S2 - for efficiency
   at_s5 := svarpt - 5                  // Address of S5 - for efficiency

   /* Set up pointers to blocks of variables which will need to be moved around */

   at_sdb, at_opdb, at_all, at_edb := @argct, @topspt, @allpt, @stakpt

   ffpt := workspace
   lfpt := workspace + size

   stffpt, endpt := ffpt, lfpt

   /* Allocate number conversion area */

   $( LET n = maxint
      AND size = 1                      // Allow for minus sign

      WHILE n > 0 DO n, size := n/10, size + 1
      bumpff(size)                      // Take space from forwards stack
      convarea := ffpt - 1              // Global pointer to end of conversion area
   $)

   /* Reserve and zeroise permanent variables */

   FOR i = 1 TO pvarnum DO
   $( !ffpt := 0
      bumpff(1)
   $)
   pvarpt := ffpt
   pvnum := pvarnum
   !ffpt := pvnum
   bumpff(1)

   glbwsw := 7

   argpt, tvarpt, stoppt, labpt, stakpt := nullpt, nullpt, nullpt, nullpt, nullpt
   skval, levl, invoct, skiplv, nestlv, oplev, tlinct := 0, 0, 0, 0, 0, 0, 0
   bindic := endchn
   linect := 1
   dbugsw := db_source
   nlsw_ := TRUE

   init_tables()                        // Initialise global hash table, and delimiter chains

   mdinit()

   /* Set up initial hash table */

   declf(1)                             // Stack null pointer to 'next' hash table
// writef("...workspace = %X8, lfpt = %X8*n", workspace, lfpt)
   !lfpt := nullpt
   hashpt := ghshtb
   stkhsh()

// writef("...hash table initialised*n")
   /* Set initial limits on local constructions */

   FOR i = 0 TO 3 DO
      hashpt!(lhv + i) := endpt
   hashpt!(lhv + 4) := 7

   knpt := knrep
   spt := ffpt - 1
   inffpt := ffpt

   /* Set up exit closure */

   exit_p, exit_l := level(), exit

   /* Start scanning */

   basic_scan()

exit:

   RESULTIS result
$)

AND mihalt() BE
/*  Machine-independent  finalisation code.  Calls the machine-dependent
finalisation   code,   prints   statistics,   and   returns    to    the
machine-dependent  logic.   'result'  is  set  to  the  number  of  ML/I
processing errors.  */
$( LET lines = 0

   mdfinal()

   lines := !at_s2
   mderpr("*NAt end of process: %N line%S, %N call%S*N", lines, lines = 1 -> "","s", invoct, invoct = 1 -> "", "s")
   result := !at_s5
   longjump(exit_p, exit_l)
$)

 .
