
// Segment 4 - Subroutines used in setting up delimiter structures (alphabetical order)

GET "ML1HDR"

LET ertest(sw) BE
$( IF sw THEN
   $( IF (ntypsw = 1) \/ (ntypsw = 4) RETURN
   $)
   erlia()
$)

AND getdel() BE
$( LET exidpt, oldspt = ?, ?
   AND type = ?

gdnext:
   type := kw_opt
   UNLESS gsratm() DO longjump(scanlevel, evexit)
                                        // End of structure representation

gd1:
   $( oldspt := spt
      UNLESS keysrc(@type) DO
      $( IF !idpt = !knpt & idlen NE 1 THEN
         $( idpt := idpt + 1
            IF mdnum() GOTO node        // Node marker was followed by a number
            idpt := idpt - 1            // Node is false alarm
         $)

         /* Case of delimiter */
   
         IF type NE kw_opt GOTO gdw1
   
         /* Place LID on forwards stack and link it up */
   
         snodch(ffpt)
         !ffpt := endchn                // Orlink
         bumpff(1)
   
      gtloop:
         !ffpt := idlen
         bumpff(1)
         $( LET lv4 = ffpt
            bumpff(idlen)
            fmove(idlen, idpt, lv4)
         $)
   
         /* Look ahead for with or withs */
   
         exidpt := idpt
         UNLESS gsratm() & keysrc(@type) DO
                                        // WITH or WITHS found
         $(
         gtexit:
            IF exidpt = spcsrp THEN
            $( !ffpt := spcsmk
               bumpff(1)
            $)
            spt := oldspt
            nodept := ffpt
            !ffpt := endchn             // Nextlink
            bumpff(1)
      
            IF optlev = 0 THEN delct := delct + 1
            nodesw, keysw := TRUE, TRUE
            RETURN
         $)
   
         /* Test for WITHS or WITH */
   
         UNLESS (type = kw_with) \/ (type = kw_withs) GOTO gtexit
         !ffpt := type = kw_with & exidpt NE spcsrp -> withmk, wthsmk
         bumpff(1)
         keysw, nodesw := FALSE, FALSE
         UNLESS gsratm() DO erlia()     // with or withs not followed by another atom
         GOTO gd1

         /* Subsequently returning here to perform checking */

      gdw1:
         TEST type = kw_withs THEN
         $( IF !idpt NE '*S' GOTO gtloop
   
            /* Convert WITHS SPACE to with SPACES */
   
            ffpt!(-1) := withmk
            idpt := spcsrp
            GOTO gtloop
         $)
         OR
         $( LET c = !idpt

            /* WITH may not separate atoms which are identifiers */

            UNLESS 'A' LE c LE 'Z' \/
                   'a' LE c LE 'z' \/
                   '0' LE c LE '9' GOTO gtloop

            c := ffpt!(-2)              // or exidpt
            UNLESS 'A' LE c LE 'Z' \/
                   'a' LE c LE 'z' \/
                   '0' LE c LE '9' GOTO gtloop
            erlia()
         $)
   
         /* Node has been found */

      node:
         ertest(nodesw)
         nodesw := FALSE
   
         /* Test whether placing or goto */
   
         UNLESS gsratm() GOTO ndgo
         IF keysrc(@type) GOTO ndkey
   
         /* Case of placing */
   
      ndplac:
         IF meval = 0 THEN erlia()      // Trying to place node zero
         consw := TRUE
         IF plnode() THEN
         $( IF !nnodpt = 1 THEN erlia() // Node already placed
            snodch(ffpt)
            nodept := tempt
         $)
         !nnodpt := 1
         nnodpt!1 := ffpt
         spt := oldspt
         GOTO gdnext
   
      ndkey:
         SWITCHON type INTO
         $( CASE kw_with:
            CASE kw_withs:
               erlia()                  // with or withs encountered immediately after a node
   
            CASE kw_opt:
               GOTO ndplac              // Node is placed
   
            CASE kw_or:
            CASE kw_all:                // Node is gone to
            ndgo:
               IF meval = 0 GOTO ndn0
               IF nodept = nullpt THEN erlia()
               UNLESS plnode() ENDCASE
               IF !nnodpt = 1 GOTO oldnod
               chanpt := tempt
               TEST chanpt NE nullpt THEN
               $( chlink := !chanpt
                  IF chlink = endchn BREAK
                  chanpt := chanpt + chlink
               $) REPEAT
               OR
                  GOTO nund1
               !chanpt := nodept - chanpt
               nodept, spt := nullpt, oldspt
               GOTO gdnext
   
            DEFAULT:
               macerr(14)
         $)
         !nnodpt := 0
   
      nund1:
         nnodpt!1 := nodept
   
      gnod3:
         nodept := nullpt
         spt := oldspt
         GOTO gdnext
   
         /* Going to old node */
   
      oldnod:
         snodch(tempt)
         GOTO gnod3
   
         /* Node N0 */
   
      ndn0:
         chanpt := nodept
         IF chanpt = nullpt THEN erlia()
         $( chlink := !chanpt
            !chanpt := exclmk
            IF chlink = endchn BREAK
            chanpt := chanpt + chlink
         $) REPEAT
         exitsw := TRUE
         GOTO gnod3
      $)

      /* Case of keyword */

      ertest(keysw)
      keysw := FALSE

      SWITCHON type INTO
      $( CASE kw_with:
         CASE kw_withs:
            erlia()                     // with or withs encountered out of context

         CASE kw_opt:
            longjump(scanlevel, evopt)

         CASE kw_or:
            longjump(scanlevel, evor)

         CASE kw_all:                   // Action at all
            joinch()
            nodept, consw := allpt, FALSE
            fmove(allsz, lfpt, at_all)
            lfpt := lfpt + allsz
            optlev := optlev - 1
            IF optlev = 0 THEN delct := delct + 1
            nodesw, keysw := TRUE, TRUE
            RETURN

         DEFAULT:
            macerr(15)
      $)
   $)
$)

AND gsratm() = VALOF
/* Yields FALSE iff end of structure representation.  */
$( IF stoppt - spt = 1 RESULTIS FALSE
   gtatom()
   IF lulayk(FALSE) = 0 RESULTIS TRUE   // Ignore layout characters
$) REPEAT

AND joinch() BE
$( IF optlev = 0 THEN erlia()           // all encountered without matching opt

   /* Add 'nodept' chain to head of 'allpt' chain */

   chanpt := nodept

   IF chanpt NE nullpt THEN
   $( $( chlink := !nodept
         IF chlink = endchn BREAK
         chanpt := chanpt + chlink
      $) REPEAT

      IF allpt NE nullpt THEN
         !chanpt := allpt - chanpt
      allpt := nodept
   $)
$)

AND keysrc(at_type) = VALOF
/*  Function  to  search  keyword  chain for a keyword.  Yields TRUE iff
keyword found; the keyword type is returned via 'at_type'.  */
$( UNLESS ludel(keychn) RESULTIS FALSE
   !at_type := chanpt!1
   RESULTIS TRUE
$)

AND plnode() = VALOF
/* Yields FALSE iff node is new.  */
$( nnodpt := lnodpt
   UNTIL nnodpt = topspt DO
   $( IF !nnodpt = meval THEN
      $( nnodpt := nnodpt + 1
         tempt := nnodpt!1
         RESULTIS TRUE
      $)
      nnodpt := nnodpt + nodesz
   $) 

   /* Reserve new node */

   ollfpt := lfpt
   declf(nodesz)
   IF lnodpt NE ollfpt THEN
   $( fmove(lnodpt - ollfpt, ollfpt, lfpt)
   $)
   lnodpt := lnodpt - nodesz
   !lnodpt := meval
   nnodpt := lnodpt + 1
   RESULTIS FALSE
$)

AND snodch(pt) BE
$( chanpt := nodept
   TEST chanpt NE nullpt THEN
   $( chlink := !chanpt
      !chanpt := pt - chanpt
      IF chlink = endchn BREAK
      chanpt := chanpt + chlink
   $) REPEAT
   OR
      UNLESS consw DO erlia()
$)

AND tespac() BE
$( UNLESS spcsmk NE !infopt NE wthsmk DO
      WHILE !idpt = withmk & idpt!2 = '*S' DO
         idpt := idpt + 3
$)

 .
